砖墙(力扣)Map + 思维 JAVA

你的面前有一堵矩形的、由 n 行砖块组成的砖墙。这些砖块高度相同(也就是一个单位高)但是宽度不同。每一行砖块的宽度之和相等。

你现在要画一条 自顶向下 的、穿过 最少

砖块的垂线。如果你画的线只是从砖块的边缘经过,就不算穿过这块砖。你不能沿着墙的两个垂直边缘之一画线,这样显然是没有穿过一块砖的。

给你一个二维数组 wall ,该数组包含这堵墙的相关信息。其中,walli

是一个代表从左至右每块砖的宽度的数组。你需要找出怎样画才能使这条线 穿过的砖块数量最少 ,并且返回 穿过的砖块数量 。

输入:wall =

\[1,2,2,1\], \[3,1,2\], \[1,3,2\], \[2,4\], \[3,1,2\], \[1,3,1,1

]

输出:2

示例 2:

输入:wall =

\[1\], \[1\], \[1

]

输出:3

提示:

n == wall.length

1 <= n <= 10^4

1 <= walli.length <= 10^4

1 <= sum(walli.length) <= 2 * 10^4

对于每一行 i ,sum(walli) 是相同的

1 <= wallij <= 2^31 - 1

解题思路:

1、正着不好求,但逆向思维:求穿过砖块边缘数的最大值有奇效

2、需要神器HashMap来更新:<砖块边缘,数量>

3、最右边砖块边缘是不符合要求的,所以不记录

4、最后用总述职砖块数 - 最大边缘数即可

代码:

java 复制代码
class Solution {
    public int leastBricks(List<List<Integer>> wall) {
    	   Map<Integer, Integer> map = new HashMap<Integer, Integer>();
           for(List<Integer> s : wall) {
        	  int len = s.size();
        	  int sum = 0;
        	  for(int i = 0; i < len - 1; i ++) {
        		  sum = sum + s.get(i);
        		  map.put(sum, map.getOrDefault(sum, 0) + 1);
        	  }
           }
           int maxres = 0;
           for(Map.Entry<Integer, Integer> a : map.entrySet()) {
        	   maxres = Math.max(maxres, a.getValue());
           }
           return wall.size() - maxres;
    }
}
相关推荐
吹什么轩2 分钟前
constexpr 完全指南:从 const 的两种含义,到编译期计算的四次演进
java·前端·javascript
她的男孩12 分钟前
租户 A 的验证码,却用了租户 B 的 AccessKey:Forge Admin 修跨租户短信串发
java·spring boot·saas
LabVIEW开发14 分钟前
LabVIEW 局部变量与数据流:这道 CLAD 题为什么答案是 Undefined
java·开发语言·labview
文丑颜不良啊14 分钟前
LeetCode1721~1740题目解析
java·leetcode
地平线开发者16 分钟前
CLIP 的训练机制:从对比学习到图文对齐
深度学习·算法·自动驾驶
wangbing112519 分钟前
监控网页项目常用英文缩写
java
麻瓜code23 分钟前
双写一致性:为什么是“删缓存“,而不是“改缓存“
java·缓存·mybatis
小蒜学长26 分钟前
基于SpringBoot+Vue的云南地区扶贫助农系统的设计与实现(代码+数据库+LW)
java·vue.js·spring boot·后端·乡村振兴
砚底藏山河34 分钟前
量化回测可复现流水线CI化
java·python·ci/cd·金融
骑着蜗牛撵大象32734 分钟前
Spring Boot 4.1 + Spring AI 2.0:RAG 供文、图谱供关系、MCP 供工具的 Java Agent 平台
java·spring boot·spring·微服务·知识图谱·rag·mcp